
#import <stdlib.h>

#define REG_TO_MEMB 0x00  
#define REG_TO_MEMW 0x01
#define MEM_TO_REGB 0x02
#define MEM_TO_REGW 0x03
#define INMEDIATO_B 0x04
#define INMEDIATO_W 0x05

#define ADD   0
#define PSH   1     /* Push  */ 
#define POP   2
#define OR    3
#define NV    4     /* Instr. no-valida */ 
#define ADC   5
#define SBB   6
#define AND   7
#define SEG   8	    /* Segment */
#define DAA   9
#define SUB  10
#define DAS  11
#define XOR  12
#define AAA  13
#define CMP  14
#define AAS  15
#define INC  16
#define DEC  17
#define JO   18
#define JNO  19
#define JB   20
#define JNB  21
#define JZ   22
#define JNZ  23
#define JNA  24
#define JA   25
#define JS   26
#define JNS  27
#define JP   28
#define JNP  29
#define JL   30
#define JGE  31
#define JG   32
#define TST  33
#define XCH  34
#define MOV  35
#define LEA  36
#define CBW  37
#define CWD  38
#define CLL  39    /* Call  */ 
#define WAI  40    /* Wait  */
#define PSF  41    /* Pushf */
#define PPF  42    /* Popf  */ 
#define SAF  43    /* Sahf  */ 
#define LAF  44    /* Lahf  */ 
#define MVS  45    /* Movs  */ 
#define CMS  46    /* Cmps  */ 
#define STS  47    /* Stos  */ 
#define LOS  48    /* Lods  */ 
#define SCS  49    /* Scas  */ 
#define RET  50 
#define LES  51
#define LDS  52
#define INT  53 
#define INO  54    /* Into  */
#define IRT  55    /* Iret  */ 
#define AAM  56  
#define AAD  57 
#define XLT  58
#define ESC  59 
#define LNZ  60   /* Loopnz / Loopne */ 
#define LZ   61   /* Loopz / Loope   */ 
#define LOO  62   /* Loop   */
#define JCZ  63   /* Jcxz   */ 
#define IN   64
#define OUT  65   
#define LCK  66   /* Lock   */ 
#define REP  67 
#define HLT  68 
#define CMC  69 
#define CLC  70 
#define STC  71 
#define CLI  72 
#define STI  73 
#define CLD  74 
#define STD  75 
#define JLE  76
#define JMP  77

#define Imm  1000
#define Shf  1001
#define Gr1  1002
#define Gr2  1003

// void registro(char *linea, char r, char w); 
void dir1(char *linea, char m, char t); 
void dir2(char *linea, char m, char t); 
void dir3(char *linea, char m, char t); 


void t_registroSegmento(char *linea, char sr);
void t_registro(char *linea, char t, char w);
void immediate_to_accumulator(char *linea, char l, char h, char *mip, int *np); 
void immediate_to_register(char *linea, char l, char h, char *mip, int *np); 
void regMem_toFrom_Register(char *linea, char l, char h, char *mip, int *np); 
void segmentRegister_to_regMem(char *linea, char l, char h, char *mip, int *np);
void regMem_to_segmentRegister(char *linea, char l, char h, char *mip, int *np);
void regSegMem_toFrom_RegisterSeg(char *linea, char l, char h, char *mip, int *np);
void immediate_to_regMem(char *linea, char l, char h, char *mip, int *np);
void acMem_to_acMem(char *linea, char l, char h, char *mip, int *np); 
void regMem(char *linea, char l, char h, char *mip, int *np);
void registro(char *linea, char l, char h, char *mip, int *np);
void registro_segmento(char *linea, char l, char h, char *mip, int *np);
void register_with_acumulator(char *linea, char l, char h, char *mip, int *np);
void fixed_port(char *linea, char l, char h, char *mip, int *np); 
void next_data8(char *linea, char h, char l, char *mip, int *np);
void reg16_from_mem16(char *linea, char h, char l, char *mip, int *np);
void type_int(char *linea, char l, char h, char *mip, int *np);
void immediate_and_register(char *linea, char l, char h, char *mip, int *np);  
void immediate_and_memory(char *linea, char l, char h, char *mip, int *np);
void direct_ws_short(char *linea, char l, char h, char *mip, int *np) ;
void direct_ws(char *linea, char l, char h, char *mip, int *np);
void direct_intersegment(char *linea, char l, char h, char *mip, int *np);
void reg_or_mem(char *linea, char l, char h, char *mip, int *np);

void immediate(char *linea, char l, char h, char *mip, int *np);
void shift(char *linea, char l, char h, char *mip, int *np);
void grupo2(char *linea, char h, char l, char *mip, int *np);

void dasm(int top, char h, char l, char *linea, char *mip, int *np); 
void desasembler(char *buff, int n);

